'
' Console Application
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
' ============================================================
$IFNDEF CALL_ASM_PROC_X
    $DEFINE CALL_ASM_PROC_X
    DECLARE FUNCTION CallAsmProc LIB "user32" ALIAS "CallWindowProcA" _
                (Proc AS LONG, A1 AS LONG, A2 AS LONG, A3 AS LONG, A4 AS LONG) AS LONG
$ENDIF
' ============================================================
' Two Usefull ASM functions for this Demo (May be done by MemCpy too)
' ============================================================
DefByte ReadDWordAtArray (0 To 12) = {&HC8, &H00, &H00, _
        &H00, &H8B, &H45, &H08, &H8B, &H00, &HC9, &HC2, &H10, &H00}
Function ReadDWordAt(address As Long) As Long
    Result = CallAsmProc (VarPtr (ReadDWordAtArray(0)), address, 0, 0, 0)
End Function
' ============================================================
DefByte WriteDWordAtArray (0 To 17) = {&HC8, &H00, &H00, _
        &H00, &H57, &H8B, &H7D, &H08, &H8B, &H45, &H0C, &H89, &H07, _
        &H5F, &HC9, &HC2, &H10, &H00}
Function WriteDWordAt(address As Long, dwData As Long) As Long
    Result = CallAsmProc ( VarPtr (WriteDWordAtArray(0)), address, dwData, 0, 0)
End Function
'
' ====================================================================================
$Include "DemoGlobalDatas.Inc"   '  The Asm Code (file in this directory)
' ====================================================================================
'
' Read the Global Data in ReadWriteGlobalDatas from RapidQ
Print "RQ Read Data_1 before write : &H";Hex$(ReadDWordAt(ptrReadWriteGlobalDatas + 8))
Print "RQ Read Data_2 before write : &H";Hex$(ReadDWordAt(ptrReadWriteGlobalDatas + 12))
Print "RQ Read Data_3 before write : &H";Hex$(ReadDWordAt(ptrReadWriteGlobalDatas + 16))
Print
' Write the Global Data in ReadWriteGlobalDatas from RapidQ
Print "RQ Write : Data_1 = &H";Hex$(WriteDWordAt (ptrReadWriteGlobalDatas + 8, &H11111111))
Print "RQ Write : Data_2 = &H";Hex$(WriteDWordAt (ptrReadWriteGlobalDatas + 12, &H22222222))
Print "RQ Write : Data_3 = &H";Hex$(WriteDWordAt (ptrReadWriteGlobalDatas + 16, &H33333333))
Print
' Read the Global Data in ReadWriteGlobalDatas from RapidQ
Print "RQ Read Data_1 after1 write : &H";Hex$(ReadDWordAt(ptrReadWriteGlobalDatas + 8))
Print "RQ Read Data_2 after1 write : &H";Hex$(ReadDWordAt(ptrReadWriteGlobalDatas + 12))
Print "RQ Read Data_3 after1 write : &H";Hex$(ReadDWordAt(ptrReadWriteGlobalDatas + 16))
'
' Run ReadWriteGlobalDatas to set the global datas from RQASM procedure datas
Print
Print "RUN RQASM PROC SETS THE GLOBAL DATAS : \n     ReadWriteGlobalDatas Returns : &H";Hex$(ReadWriteGlobalDatas)
' Read the Global Data in ptrReadWriteGlobalDatas from RapidQ
Print "RQ Read Data_1 after2 RqAsm write : &H";Hex$(ReadDWordAt(ptrReadWriteGlobalDatas + 8))
Print "RQ Read Data_2 after2 Rqasm write : &H";Hex$(ReadDWordAt(ptrReadWriteGlobalDatas + 12))
Print "RQ Read Data_3 after2 RqAsm write : &H";Hex$(ReadDWordAt(ptrReadWriteGlobalDatas + 16))
'
' -------------------------------------------------------------
' EXIT CONSOLE
' ------------
DefStr sExit
Input "\n\n                    CR to QUIT \n\n", sExit
Application.Terminate
End
';
'; Demonstrates how to create and use Global datas in RqAsm
'; --------------------------------------------------------
';
'; MIRACLE : when calling a function from RapidQ via CallWindowProc, EAX is the address called
'; So any Label in your code will have an address of   EAX + LABEL
';
'; Accessing these datas from RapidQ : The first byte of datas is at the address you call to 
'; run the ASM procedure + 8 when you use the TIP used here (jmp .OverDatas)
'; If you dont use the same NASM skeleton, that '8' value may be different. Check that value
'; in the Nasm List File (With Enter 0,0 and Leave instead of push-pop ebp-esp, that value is
'; 9 .
';
'Function ReadWriteGlobalDatas
';
'         jmp       .overdatas
'; three dword of Global Datas
'    .Data_1:       dd 0xAAAAAAAA                 ; address = ptrReadStaticDatas +  8 (.Data_1 = 8)
'    .Data_2:       dd 0xBBBBBBBB                 ; address = ptrReadStaticDatas + 12 (.Data_2 = 12)
'    .Data_3:       dd 0xCCCCCCCC                 ; address = ptrReadStaticDatas + 16 (.Data_2 = 16)
'; space 512 bytes of global/static datas initialised to 0
'    .mySpace:      times 64 db 0x00              ; address = ptrReadStaticDatas + 21 (.mySpace = 20)
'    .overdatas:
';
'; read and return 'global data' .myData       
'         mov       esi,       eax                ; save eax the ptr to this code in esi
'         mov       dword     [esi+.Data_3],         0x99999999         ; write in Data_3
'         mov       dword     [esi+.Data_2],         0x88888888         ; write in Data_2
'         mov       dword     [esi+.Data_1],         0x77777777         ; write in Data_1
'         mov       eax,      [esi+.Data_1]       ; read global data_1 in eax and return it
'         pop       esi
'End Function
';
'